/**
 * output package name
 */
package com.kingdee.eas.custom.permissioncontrol.client;

import org.apache.log4j.*;

import java.awt.*;
import java.awt.event.*;
import java.util.*;
import javax.swing.border.*;
import javax.swing.BorderFactory;
import javax.swing.event.*;
import javax.swing.KeyStroke;

import com.kingdee.bos.ctrl.swing.*;
import com.kingdee.bos.ctrl.kdf.table.*;
import com.kingdee.bos.ctrl.kdf.data.event.*;
import com.kingdee.bos.dao.*;
import com.kingdee.bos.dao.query.*;
import com.kingdee.bos.metadata.*;
import com.kingdee.bos.metadata.entity.*;
import com.kingdee.bos.ui.face.*;
import com.kingdee.bos.ui.util.ResourceBundleHelper;
import com.kingdee.bos.util.BOSUuid;
import com.kingdee.bos.service.ServiceContext;
import com.kingdee.jdbc.rowset.IRowSet;
import com.kingdee.util.enums.EnumUtils;
import com.kingdee.bos.ui.face.UIRuleUtil;
import com.kingdee.bos.ctrl.swing.event.*;
import com.kingdee.bos.ctrl.kdf.table.event.*;
import com.kingdee.bos.ctrl.extendcontrols.*;
import com.kingdee.bos.ctrl.kdf.util.render.*;
import com.kingdee.bos.ui.face.IItemAction;
import com.kingdee.eas.framework.batchHandler.RequestContext;
import com.kingdee.bos.ui.util.IUIActionPostman;
import com.kingdee.bos.appframework.client.servicebinding.ActionProxyFactory;
import com.kingdee.bos.appframework.uistatemanage.ActionStateConst;
import com.kingdee.bos.appframework.validator.ValidateHelper;
import com.kingdee.bos.appframework.uip.UINavigator;


/**
 * output class name
 */
public abstract class AbstractPermApplyBillEditUI extends com.kingdee.eas.framework.client.CoreBillEditUI
{
    private static final Logger logger = CoreUIObject.getLogger(AbstractPermApplyBillEditUI.class);
    protected com.kingdee.bos.ctrl.swing.KDLabelContainer contCreator;
    protected com.kingdee.bos.ctrl.swing.KDLabelContainer contCreateTime;
    protected com.kingdee.bos.ctrl.swing.KDLabelContainer contLastUpdateUser;
    protected com.kingdee.bos.ctrl.swing.KDLabelContainer contLastUpdateTime;
    protected com.kingdee.bos.ctrl.swing.KDLabelContainer contNumber;
    protected com.kingdee.bos.ctrl.swing.KDLabelContainer contBizDate;
    protected com.kingdee.bos.ctrl.swing.KDLabelContainer contDescription;
    protected com.kingdee.bos.ctrl.swing.KDLabelContainer contAuditor;
    protected com.kingdee.bos.ctrl.swing.KDLabelContainer conteffectiveDate;
    protected com.kingdee.bos.ctrl.swing.KDLabelContainer contapplyReason;
    protected com.kingdee.bos.ctrl.swing.KDLabelContainer contapplyPerson;
    protected com.kingdee.bos.ctrl.kdf.table.KDTable kdtRolePermApplys;
	protected com.kingdee.eas.framework.client.multiDetail.DetailPanel kdtRolePermApplys_detailPanel = null;
    protected com.kingdee.bos.ctrl.kdf.table.KDTable kdtOrgScopeApply;
	protected com.kingdee.eas.framework.client.multiDetail.DetailPanel kdtOrgScopeApply_detailPanel = null;
    protected com.kingdee.bos.ctrl.kdf.table.KDTable kdtHisRolePermApplyHis;
	protected com.kingdee.eas.framework.client.multiDetail.DetailPanel kdtHisRolePermApplyHis_detailPanel = null;
    protected com.kingdee.bos.ctrl.kdf.table.KDTable kdtHisOrgScopeApplyEntry;
	protected com.kingdee.eas.framework.client.multiDetail.DetailPanel kdtHisOrgScopeApplyEntry_detailPanel = null;
    protected com.kingdee.bos.ctrl.swing.KDCheckBox chkisEffective;
    protected com.kingdee.bos.ctrl.extendcontrols.KDBizPromptBox prmtCreator;
    protected com.kingdee.bos.ctrl.swing.KDDatePicker kDDateCreateTime;
    protected com.kingdee.bos.ctrl.extendcontrols.KDBizPromptBox prmtLastUpdateUser;
    protected com.kingdee.bos.ctrl.swing.KDDatePicker kDDateLastUpdateTime;
    protected com.kingdee.bos.ctrl.swing.KDTextField txtNumber;
    protected com.kingdee.bos.ctrl.swing.KDDatePicker pkBizDate;
    protected com.kingdee.bos.ctrl.swing.KDTextField txtDescription;
    protected com.kingdee.bos.ctrl.extendcontrols.KDBizPromptBox prmtAuditor;
    protected com.kingdee.bos.ctrl.swing.KDDatePicker pkeffectiveDate;
    protected com.kingdee.bos.ctrl.swing.KDScrollPane scrollPaneapplyReason;
    protected com.kingdee.bos.ctrl.swing.KDTextArea txtapplyReason;
    protected com.kingdee.bos.ctrl.extendcontrols.KDBizPromptBox prmtapplyPerson;
    protected com.kingdee.eas.custom.permissioncontrol.PermApplyBillInfo editData = null;
    /**
     * output class constructor
     */
    public AbstractPermApplyBillEditUI() throws Exception
    {
        super();
        this.defaultObjectName = "editData";
        jbInit();
        
        initUIP();
    }

    /**
     * output jbInit method
     */
    private void jbInit() throws Exception
    {
        this.resHelper = new ResourceBundleHelper(AbstractPermApplyBillEditUI.class.getName());
        this.setUITitle(resHelper.getString("this.title"));
        //actionSubmit
        String _tempStr = null;
        actionSubmit.setEnabled(true);
        actionSubmit.setDaemonRun(false);

        actionSubmit.putValue(ItemAction.ACCELERATOR_KEY, KeyStroke.getKeyStroke("ctrl S"));
        _tempStr = resHelper.getString("ActionSubmit.SHORT_DESCRIPTION");
        actionSubmit.putValue(ItemAction.SHORT_DESCRIPTION, _tempStr);
        _tempStr = resHelper.getString("ActionSubmit.LONG_DESCRIPTION");
        actionSubmit.putValue(ItemAction.LONG_DESCRIPTION, _tempStr);
        _tempStr = resHelper.getString("ActionSubmit.NAME");
        actionSubmit.putValue(ItemAction.NAME, _tempStr);
        this.actionSubmit.setBindWorkFlow(true);
        this.actionSubmit.setExtendProperty("canForewarn", "true");
         this.actionSubmit.addService(new com.kingdee.eas.framework.client.service.PermissionService());
         this.actionSubmit.addService(new com.kingdee.eas.framework.client.service.NetFunctionService());
         this.actionSubmit.addService(new com.kingdee.eas.framework.client.service.UserMonitorService());
         this.actionSubmit.addService(new com.kingdee.eas.framework.client.service.ForewarnService());
        //actionPrint
        actionPrint.setEnabled(true);
        actionPrint.setDaemonRun(false);

        actionPrint.putValue(ItemAction.ACCELERATOR_KEY, KeyStroke.getKeyStroke("ctrl P"));
        _tempStr = resHelper.getString("ActionPrint.SHORT_DESCRIPTION");
        actionPrint.putValue(ItemAction.SHORT_DESCRIPTION, _tempStr);
        _tempStr = resHelper.getString("ActionPrint.LONG_DESCRIPTION");
        actionPrint.putValue(ItemAction.LONG_DESCRIPTION, _tempStr);
        _tempStr = resHelper.getString("ActionPrint.NAME");
        actionPrint.putValue(ItemAction.NAME, _tempStr);
         this.actionPrint.addService(new com.kingdee.eas.framework.client.service.PermissionService());
         this.actionPrint.addService(new com.kingdee.eas.framework.client.service.NetFunctionService());
         this.actionPrint.addService(new com.kingdee.eas.framework.client.service.UserMonitorService());
        //actionPrintPreview
        actionPrintPreview.setEnabled(true);
        actionPrintPreview.setDaemonRun(false);

        actionPrintPreview.putValue(ItemAction.ACCELERATOR_KEY, KeyStroke.getKeyStroke("shift ctrl P"));
        _tempStr = resHelper.getString("ActionPrintPreview.SHORT_DESCRIPTION");
        actionPrintPreview.putValue(ItemAction.SHORT_DESCRIPTION, _tempStr);
        _tempStr = resHelper.getString("ActionPrintPreview.LONG_DESCRIPTION");
        actionPrintPreview.putValue(ItemAction.LONG_DESCRIPTION, _tempStr);
        _tempStr = resHelper.getString("ActionPrintPreview.NAME");
        actionPrintPreview.putValue(ItemAction.NAME, _tempStr);
         this.actionPrintPreview.addService(new com.kingdee.eas.framework.client.service.PermissionService());
         this.actionPrintPreview.addService(new com.kingdee.eas.framework.client.service.NetFunctionService());
         this.actionPrintPreview.addService(new com.kingdee.eas.framework.client.service.UserMonitorService());
        this.contCreator = new com.kingdee.bos.ctrl.swing.KDLabelContainer();
        this.contCreateTime = new com.kingdee.bos.ctrl.swing.KDLabelContainer();
        this.contLastUpdateUser = new com.kingdee.bos.ctrl.swing.KDLabelContainer();
        this.contLastUpdateTime = new com.kingdee.bos.ctrl.swing.KDLabelContainer();
        this.contNumber = new com.kingdee.bos.ctrl.swing.KDLabelContainer();
        this.contBizDate = new com.kingdee.bos.ctrl.swing.KDLabelContainer();
        this.contDescription = new com.kingdee.bos.ctrl.swing.KDLabelContainer();
        this.contAuditor = new com.kingdee.bos.ctrl.swing.KDLabelContainer();
        this.conteffectiveDate = new com.kingdee.bos.ctrl.swing.KDLabelContainer();
        this.contapplyReason = new com.kingdee.bos.ctrl.swing.KDLabelContainer();
        this.contapplyPerson = new com.kingdee.bos.ctrl.swing.KDLabelContainer();
        this.kdtRolePermApplys = new com.kingdee.bos.ctrl.kdf.table.KDTable();
        this.kdtOrgScopeApply = new com.kingdee.bos.ctrl.kdf.table.KDTable();
        this.kdtHisRolePermApplyHis = new com.kingdee.bos.ctrl.kdf.table.KDTable();
        this.kdtHisOrgScopeApplyEntry = new com.kingdee.bos.ctrl.kdf.table.KDTable();
        this.chkisEffective = new com.kingdee.bos.ctrl.swing.KDCheckBox();
        this.prmtCreator = new com.kingdee.bos.ctrl.extendcontrols.KDBizPromptBox();
        this.kDDateCreateTime = new com.kingdee.bos.ctrl.swing.KDDatePicker();
        this.prmtLastUpdateUser = new com.kingdee.bos.ctrl.extendcontrols.KDBizPromptBox();
        this.kDDateLastUpdateTime = new com.kingdee.bos.ctrl.swing.KDDatePicker();
        this.txtNumber = new com.kingdee.bos.ctrl.swing.KDTextField();
        this.pkBizDate = new com.kingdee.bos.ctrl.swing.KDDatePicker();
        this.txtDescription = new com.kingdee.bos.ctrl.swing.KDTextField();
        this.prmtAuditor = new com.kingdee.bos.ctrl.extendcontrols.KDBizPromptBox();
        this.pkeffectiveDate = new com.kingdee.bos.ctrl.swing.KDDatePicker();
        this.scrollPaneapplyReason = new com.kingdee.bos.ctrl.swing.KDScrollPane();
        this.txtapplyReason = new com.kingdee.bos.ctrl.swing.KDTextArea();
        this.prmtapplyPerson = new com.kingdee.bos.ctrl.extendcontrols.KDBizPromptBox();
        this.contCreator.setName("contCreator");
        this.contCreateTime.setName("contCreateTime");
        this.contLastUpdateUser.setName("contLastUpdateUser");
        this.contLastUpdateTime.setName("contLastUpdateTime");
        this.contNumber.setName("contNumber");
        this.contBizDate.setName("contBizDate");
        this.contDescription.setName("contDescription");
        this.contAuditor.setName("contAuditor");
        this.conteffectiveDate.setName("conteffectiveDate");
        this.contapplyReason.setName("contapplyReason");
        this.contapplyPerson.setName("contapplyPerson");
        this.kdtRolePermApplys.setName("kdtRolePermApplys");
        this.kdtOrgScopeApply.setName("kdtOrgScopeApply");
        this.kdtHisRolePermApplyHis.setName("kdtHisRolePermApplyHis");
        this.kdtHisOrgScopeApplyEntry.setName("kdtHisOrgScopeApplyEntry");
        this.chkisEffective.setName("chkisEffective");
        this.prmtCreator.setName("prmtCreator");
        this.kDDateCreateTime.setName("kDDateCreateTime");
        this.prmtLastUpdateUser.setName("prmtLastUpdateUser");
        this.kDDateLastUpdateTime.setName("kDDateLastUpdateTime");
        this.txtNumber.setName("txtNumber");
        this.pkBizDate.setName("pkBizDate");
        this.txtDescription.setName("txtDescription");
        this.prmtAuditor.setName("prmtAuditor");
        this.pkeffectiveDate.setName("pkeffectiveDate");
        this.scrollPaneapplyReason.setName("scrollPaneapplyReason");
        this.txtapplyReason.setName("txtapplyReason");
        this.prmtapplyPerson.setName("prmtapplyPerson");
        // CoreUI		
        this.btnTraceUp.setVisible(false);		
        this.btnTraceDown.setVisible(false);		
        this.btnCreateTo.setVisible(true);		
        this.btnAddLine.setVisible(false);		
        this.btnCopyLine.setVisible(false);		
        this.btnInsertLine.setVisible(false);		
        this.btnRemoveLine.setVisible(false);		
        this.btnAuditResult.setVisible(false);		
        this.separator1.setVisible(false);		
        this.menuItemCreateTo.setVisible(true);		
        this.separator3.setVisible(false);		
        this.menuItemTraceUp.setVisible(false);		
        this.menuItemTraceDown.setVisible(false);		
        this.menuTable1.setVisible(false);		
        this.menuItemAddLine.setVisible(false);		
        this.menuItemCopyLine.setVisible(false);		
        this.menuItemInsertLine.setVisible(false);		
        this.menuItemRemoveLine.setVisible(false);		
        this.menuItemViewSubmitProccess.setVisible(false);		
        this.menuItemViewDoProccess.setVisible(false);		
        this.menuItemAuditResult.setVisible(false);
        // contCreator		
        this.contCreator.setBoundLabelText(resHelper.getString("contCreator.boundLabelText"));		
        this.contCreator.setBoundLabelLength(100);		
        this.contCreator.setBoundLabelUnderline(true);		
        this.contCreator.setEnabled(false);
        // contCreateTime		
        this.contCreateTime.setBoundLabelText(resHelper.getString("contCreateTime.boundLabelText"));		
        this.contCreateTime.setBoundLabelLength(100);		
        this.contCreateTime.setBoundLabelUnderline(true);		
        this.contCreateTime.setEnabled(false);
        // contLastUpdateUser		
        this.contLastUpdateUser.setBoundLabelText(resHelper.getString("contLastUpdateUser.boundLabelText"));		
        this.contLastUpdateUser.setBoundLabelLength(100);		
        this.contLastUpdateUser.setBoundLabelUnderline(true);		
        this.contLastUpdateUser.setEnabled(false);		
        this.contLastUpdateUser.setVisible(false);
        // contLastUpdateTime		
        this.contLastUpdateTime.setBoundLabelText(resHelper.getString("contLastUpdateTime.boundLabelText"));		
        this.contLastUpdateTime.setBoundLabelLength(100);		
        this.contLastUpdateTime.setBoundLabelUnderline(true);		
        this.contLastUpdateTime.setEnabled(false);		
        this.contLastUpdateTime.setVisible(false);
        // contNumber		
        this.contNumber.setBoundLabelText(resHelper.getString("contNumber.boundLabelText"));		
        this.contNumber.setBoundLabelLength(100);		
        this.contNumber.setBoundLabelUnderline(true);
        // contBizDate		
        this.contBizDate.setBoundLabelText(resHelper.getString("contBizDate.boundLabelText"));		
        this.contBizDate.setBoundLabelLength(100);		
        this.contBizDate.setBoundLabelUnderline(true);		
        this.contBizDate.setBoundLabelAlignment(7);		
        this.contBizDate.setVisible(true);
        // contDescription		
        this.contDescription.setBoundLabelText(resHelper.getString("contDescription.boundLabelText"));		
        this.contDescription.setBoundLabelLength(100);		
        this.contDescription.setBoundLabelUnderline(true);
        // contAuditor		
        this.contAuditor.setBoundLabelText(resHelper.getString("contAuditor.boundLabelText"));		
        this.contAuditor.setBoundLabelLength(100);		
        this.contAuditor.setBoundLabelUnderline(true);
        // conteffectiveDate		
        this.conteffectiveDate.setBoundLabelText(resHelper.getString("conteffectiveDate.boundLabelText"));		
        this.conteffectiveDate.setBoundLabelLength(100);		
        this.conteffectiveDate.setBoundLabelUnderline(true);		
        this.conteffectiveDate.setVisible(true);
        // contapplyReason		
        this.contapplyReason.setBoundLabelText(resHelper.getString("contapplyReason.boundLabelText"));		
        this.contapplyReason.setBoundLabelLength(100);		
        this.contapplyReason.setBoundLabelUnderline(true);		
        this.contapplyReason.setVisible(true);
        // contapplyPerson		
        this.contapplyPerson.setBoundLabelText(resHelper.getString("contapplyPerson.boundLabelText"));		
        this.contapplyPerson.setBoundLabelLength(100);		
        this.contapplyPerson.setBoundLabelUnderline(true);		
        this.contapplyPerson.setVisible(true);
        // kdtRolePermApplys
		String kdtRolePermApplysStrXML = "<?xml version=\"1.0\" encoding=\"UTF-8\"?><DocRoot xmlns:c=\"http://www.kingdee.com/Common\" xmlns:f=\"http://www.kingdee.com/Form\" xmlns:t=\"http://www.kingdee.com/Table\" xmlns:xsi=\"http://www.w3.org/2001/XMLSchema-instance\" xsi:schemaLocation=\"http://www.kingdee.com/KDF KDFSchema.xsd\" version=\"0.0\"><Styles><c:Style id=\"sCol0\"><c:NumberFormat>&amp;int</c:NumberFormat></c:Style><c:Style id=\"sCol2\"><c:NumberFormat>&amp;int</c:NumberFormat></c:Style></Styles><Table id=\"KDTable\"><t:Sheet name=\"sheet1\"><t:Table t:selectMode=\"15\" t:mergeMode=\"0\" t:dataRequestMode=\"0\" t:pageRowCount=\"100\"><t:ColumnGroup><t:Column t:key=\"seq\" t:width=\"-1\" t:mergeable=\"true\" t:resizeable=\"true\" t:moveable=\"true\" t:group=\"false\" t:required=\"false\" t:index=\"-1\" t:styleID=\"sCol0\" /><t:Column t:key=\"role\" t:width=\"-1\" t:mergeable=\"true\" t:resizeable=\"true\" t:moveable=\"true\" t:group=\"false\" t:required=\"false\" t:index=\"-1\" /><t:Column t:key=\"permCount\" t:width=\"-1\" t:mergeable=\"true\" t:resizeable=\"true\" t:moveable=\"true\" t:group=\"false\" t:required=\"false\" t:index=\"-1\" t:styleID=\"sCol2\" /><t:Column t:key=\"remark\" t:width=\"-1\" t:mergeable=\"true\" t:resizeable=\"true\" t:moveable=\"true\" t:group=\"false\" t:required=\"false\" t:index=\"-1\" /><t:Column t:key=\"operationType\" t:width=\"-1\" t:mergeable=\"true\" t:resizeable=\"true\" t:moveable=\"true\" t:group=\"false\" t:required=\"false\" t:index=\"-1\" /></t:ColumnGroup><t:Head><t:Row t:name=\"header\" t:height=\"-1\" t:mergeable=\"true\" t:resizeable=\"true\"><t:Cell>$Resource{seq}</t:Cell><t:Cell>$Resource{role}</t:Cell><t:Cell>$Resource{permCount}</t:Cell><t:Cell>$Resource{remark}</t:Cell><t:Cell>$Resource{operationType}</t:Cell></t:Row></t:Head></t:Table><t:SheetOptions><t:MergeBlocks><t:Head /></t:MergeBlocks></t:SheetOptions></t:Sheet></Table></DocRoot>";
		
        this.kdtRolePermApplys.setFormatXml(resHelper.translateString("kdtRolePermApplys",kdtRolePermApplysStrXML));

                this.kdtRolePermApplys.putBindContents("editData",new String[] {"seq","role","permCount","remark","operationType"});


        this.kdtRolePermApplys.checkParsed();
        KDFormattedTextField kdtRolePermApplys_permCount_TextField = new KDFormattedTextField();
        kdtRolePermApplys_permCount_TextField.setName("kdtRolePermApplys_permCount_TextField");
        kdtRolePermApplys_permCount_TextField.setVisible(true);
        kdtRolePermApplys_permCount_TextField.setEditable(true);
        kdtRolePermApplys_permCount_TextField.setHorizontalAlignment(2);
        kdtRolePermApplys_permCount_TextField.setDataType(0);
        KDTDefaultCellEditor kdtRolePermApplys_permCount_CellEditor = new KDTDefaultCellEditor(kdtRolePermApplys_permCount_TextField);
        this.kdtRolePermApplys.getColumn("permCount").setEditor(kdtRolePermApplys_permCount_CellEditor);
        KDTextArea kdtRolePermApplys_remark_TextArea = new KDTextArea();
        kdtRolePermApplys_remark_TextArea.setName("kdtRolePermApplys_remark_TextArea");
        kdtRolePermApplys_remark_TextArea.setMaxLength(2000);
        KDTDefaultCellEditor kdtRolePermApplys_remark_CellEditor = new KDTDefaultCellEditor(kdtRolePermApplys_remark_TextArea);
        this.kdtRolePermApplys.getColumn("remark").setEditor(kdtRolePermApplys_remark_CellEditor);
        KDComboBox kdtRolePermApplys_operationType_ComboBox = new KDComboBox();
        kdtRolePermApplys_operationType_ComboBox.setName("kdtRolePermApplys_operationType_ComboBox");
        kdtRolePermApplys_operationType_ComboBox.setVisible(true);
        kdtRolePermApplys_operationType_ComboBox.addItems(EnumUtils.getEnumList("com.kingdee.eas.custom.permissioncontrol.bizEnum.OperationTypeEnum").toArray());
        KDTDefaultCellEditor kdtRolePermApplys_operationType_CellEditor = new KDTDefaultCellEditor(kdtRolePermApplys_operationType_ComboBox);
        this.kdtRolePermApplys.getColumn("operationType").setEditor(kdtRolePermApplys_operationType_CellEditor);
        // kdtOrgScopeApply
		String kdtOrgScopeApplyStrXML = "<?xml version=\"1.0\" encoding=\"UTF-8\"?><DocRoot xmlns:c=\"http://www.kingdee.com/Common\" xmlns:f=\"http://www.kingdee.com/Form\" xmlns:t=\"http://www.kingdee.com/Table\" xmlns:xsi=\"http://www.w3.org/2001/XMLSchema-instance\" xsi:schemaLocation=\"http://www.kingdee.com/KDF KDFSchema.xsd\" version=\"0.0\"><Styles><c:Style id=\"sCol0\"><c:NumberFormat>&amp;int</c:NumberFormat></c:Style></Styles><Table id=\"KDTable\"><t:Sheet name=\"sheet1\"><t:Table t:selectMode=\"15\" t:mergeMode=\"0\" t:dataRequestMode=\"0\" t:pageRowCount=\"100\"><t:ColumnGroup><t:Column t:key=\"seq\" t:width=\"-1\" t:mergeable=\"true\" t:resizeable=\"true\" t:moveable=\"true\" t:group=\"false\" t:required=\"false\" t:index=\"-1\" t:styleID=\"sCol0\" /><t:Column t:key=\"orgUnit\" t:width=\"-1\" t:mergeable=\"true\" t:resizeable=\"true\" t:moveable=\"true\" t:group=\"false\" t:required=\"false\" t:index=\"-1\" /><t:Column t:key=\"isIncludeSub\" t:width=\"-1\" t:mergeable=\"true\" t:resizeable=\"true\" t:moveable=\"true\" t:group=\"false\" t:required=\"false\" t:index=\"-1\" /></t:ColumnGroup><t:Head><t:Row t:name=\"header\" t:height=\"-1\" t:mergeable=\"true\" t:resizeable=\"true\"><t:Cell>$Resource{seq}</t:Cell><t:Cell>$Resource{orgUnit}</t:Cell><t:Cell>$Resource{isIncludeSub}</t:Cell></t:Row></t:Head></t:Table><t:SheetOptions><t:MergeBlocks><t:Head /></t:MergeBlocks></t:SheetOptions></t:Sheet></Table></DocRoot>";
		
        this.kdtOrgScopeApply.setFormatXml(resHelper.translateString("kdtOrgScopeApply",kdtOrgScopeApplyStrXML));

                this.kdtOrgScopeApply.putBindContents("editData",new String[] {"seq","orgUnit","isIncludeSub"});


        this.kdtOrgScopeApply.checkParsed();
        final KDBizPromptBox kdtOrgScopeApply_orgUnit_PromptBox = new KDBizPromptBox();
        kdtOrgScopeApply_orgUnit_PromptBox.setQueryInfo("com.kingdee.eas.basedata.org.app.AdminItemQuery");
        kdtOrgScopeApply_orgUnit_PromptBox.setVisible(true);
        kdtOrgScopeApply_orgUnit_PromptBox.setEditable(true);
        kdtOrgScopeApply_orgUnit_PromptBox.setDisplayFormat("$number$");
        kdtOrgScopeApply_orgUnit_PromptBox.setEditFormat("$number$");
        kdtOrgScopeApply_orgUnit_PromptBox.setCommitFormat("$number$");
        KDTDefaultCellEditor kdtOrgScopeApply_orgUnit_CellEditor = new KDTDefaultCellEditor(kdtOrgScopeApply_orgUnit_PromptBox);
        this.kdtOrgScopeApply.getColumn("orgUnit").setEditor(kdtOrgScopeApply_orgUnit_CellEditor);
        ObjectValueRender kdtOrgScopeApply_orgUnit_OVR = new ObjectValueRender();
        kdtOrgScopeApply_orgUnit_OVR.setFormat(new BizDataFormat("$name$"));
        this.kdtOrgScopeApply.getColumn("orgUnit").setRenderer(kdtOrgScopeApply_orgUnit_OVR);
        KDCheckBox kdtOrgScopeApply_isIncludeSub_CheckBox = new KDCheckBox();
        kdtOrgScopeApply_isIncludeSub_CheckBox.setName("kdtOrgScopeApply_isIncludeSub_CheckBox");
        KDTDefaultCellEditor kdtOrgScopeApply_isIncludeSub_CellEditor = new KDTDefaultCellEditor(kdtOrgScopeApply_isIncludeSub_CheckBox);
        this.kdtOrgScopeApply.getColumn("isIncludeSub").setEditor(kdtOrgScopeApply_isIncludeSub_CellEditor);
        // kdtHisRolePermApplyHis
		String kdtHisRolePermApplyHisStrXML = "<?xml version=\"1.0\" encoding=\"UTF-8\"?><DocRoot xmlns:c=\"http://www.kingdee.com/Common\" xmlns:f=\"http://www.kingdee.com/Form\" xmlns:t=\"http://www.kingdee.com/Table\" xmlns:xsi=\"http://www.w3.org/2001/XMLSchema-instance\" xsi:schemaLocation=\"http://www.kingdee.com/KDF KDFSchema.xsd\" version=\"0.0\"><Styles><c:Style id=\"sCol0\"><c:NumberFormat>&amp;int</c:NumberFormat></c:Style></Styles><Table id=\"KDTable\"><t:Sheet name=\"sheet1\"><t:Table t:selectMode=\"15\" t:mergeMode=\"0\" t:dataRequestMode=\"0\" t:pageRowCount=\"100\"><t:ColumnGroup><t:Column t:key=\"seq\" t:width=\"-1\" t:mergeable=\"true\" t:resizeable=\"true\" t:moveable=\"true\" t:group=\"false\" t:required=\"false\" t:index=\"-1\" t:styleID=\"sCol0\" /><t:Column t:key=\"role\" t:width=\"-1\" t:mergeable=\"true\" t:resizeable=\"true\" t:moveable=\"true\" t:group=\"false\" t:required=\"false\" t:index=\"-1\" /></t:ColumnGroup><t:Head><t:Row t:name=\"header\" t:height=\"-1\" t:mergeable=\"true\" t:resizeable=\"true\"><t:Cell>$Resource{seq}</t:Cell><t:Cell>$Resource{role}</t:Cell></t:Row></t:Head></t:Table><t:SheetOptions><t:MergeBlocks><t:Head /></t:MergeBlocks></t:SheetOptions></t:Sheet></Table></DocRoot>";
		
        this.kdtHisRolePermApplyHis.setFormatXml(resHelper.translateString("kdtHisRolePermApplyHis",kdtHisRolePermApplyHisStrXML));

                this.kdtHisRolePermApplyHis.putBindContents("editData",new String[] {"seq","role"});


        this.kdtHisRolePermApplyHis.checkParsed();
        // kdtHisOrgScopeApplyEntry
		String kdtHisOrgScopeApplyEntryStrXML = "<?xml version=\"1.0\" encoding=\"UTF-8\"?><DocRoot xmlns:c=\"http://www.kingdee.com/Common\" xmlns:f=\"http://www.kingdee.com/Form\" xmlns:t=\"http://www.kingdee.com/Table\" xmlns:xsi=\"http://www.w3.org/2001/XMLSchema-instance\" xsi:schemaLocation=\"http://www.kingdee.com/KDF KDFSchema.xsd\" version=\"0.0\"><Styles><c:Style id=\"sCol0\"><c:NumberFormat>&amp;int</c:NumberFormat></c:Style></Styles><Table id=\"KDTable\"><t:Sheet name=\"sheet1\"><t:Table t:selectMode=\"15\" t:mergeMode=\"0\" t:dataRequestMode=\"0\" t:pageRowCount=\"100\"><t:ColumnGroup><t:Column t:key=\"seq\" t:width=\"-1\" t:mergeable=\"true\" t:resizeable=\"true\" t:moveable=\"true\" t:group=\"false\" t:required=\"false\" t:index=\"-1\" t:styleID=\"sCol0\" /><t:Column t:key=\"orgUnit\" t:width=\"-1\" t:mergeable=\"true\" t:resizeable=\"true\" t:moveable=\"true\" t:group=\"false\" t:required=\"false\" t:index=\"-1\" /><t:Column t:key=\"isIncludeSub\" t:width=\"-1\" t:mergeable=\"true\" t:resizeable=\"true\" t:moveable=\"true\" t:group=\"false\" t:required=\"false\" t:index=\"-1\" /></t:ColumnGroup><t:Head><t:Row t:name=\"header\" t:height=\"-1\" t:mergeable=\"true\" t:resizeable=\"true\"><t:Cell>$Resource{seq}</t:Cell><t:Cell>$Resource{orgUnit}</t:Cell><t:Cell>$Resource{isIncludeSub}</t:Cell></t:Row></t:Head></t:Table><t:SheetOptions><t:MergeBlocks><t:Head /></t:MergeBlocks></t:SheetOptions></t:Sheet></Table></DocRoot>";
		
        this.kdtHisOrgScopeApplyEntry.setFormatXml(resHelper.translateString("kdtHisOrgScopeApplyEntry",kdtHisOrgScopeApplyEntryStrXML));

                this.kdtHisOrgScopeApplyEntry.putBindContents("editData",new String[] {"seq","orgUnit","isIncludeSub"});


        this.kdtHisOrgScopeApplyEntry.checkParsed();
        final KDBizPromptBox kdtHisOrgScopeApplyEntry_orgUnit_PromptBox = new KDBizPromptBox();
        kdtHisOrgScopeApplyEntry_orgUnit_PromptBox.setQueryInfo("com.kingdee.eas.basedata.org.app.AdminItemQuery");
        kdtHisOrgScopeApplyEntry_orgUnit_PromptBox.setVisible(true);
        kdtHisOrgScopeApplyEntry_orgUnit_PromptBox.setEditable(true);
        kdtHisOrgScopeApplyEntry_orgUnit_PromptBox.setDisplayFormat("$number$");
        kdtHisOrgScopeApplyEntry_orgUnit_PromptBox.setEditFormat("$number$");
        kdtHisOrgScopeApplyEntry_orgUnit_PromptBox.setCommitFormat("$number$");
        KDTDefaultCellEditor kdtHisOrgScopeApplyEntry_orgUnit_CellEditor = new KDTDefaultCellEditor(kdtHisOrgScopeApplyEntry_orgUnit_PromptBox);
        this.kdtHisOrgScopeApplyEntry.getColumn("orgUnit").setEditor(kdtHisOrgScopeApplyEntry_orgUnit_CellEditor);
        ObjectValueRender kdtHisOrgScopeApplyEntry_orgUnit_OVR = new ObjectValueRender();
        kdtHisOrgScopeApplyEntry_orgUnit_OVR.setFormat(new BizDataFormat("$name$"));
        this.kdtHisOrgScopeApplyEntry.getColumn("orgUnit").setRenderer(kdtHisOrgScopeApplyEntry_orgUnit_OVR);
        KDCheckBox kdtHisOrgScopeApplyEntry_isIncludeSub_CheckBox = new KDCheckBox();
        kdtHisOrgScopeApplyEntry_isIncludeSub_CheckBox.setName("kdtHisOrgScopeApplyEntry_isIncludeSub_CheckBox");
        KDTDefaultCellEditor kdtHisOrgScopeApplyEntry_isIncludeSub_CellEditor = new KDTDefaultCellEditor(kdtHisOrgScopeApplyEntry_isIncludeSub_CheckBox);
        this.kdtHisOrgScopeApplyEntry.getColumn("isIncludeSub").setEditor(kdtHisOrgScopeApplyEntry_isIncludeSub_CellEditor);
        // chkisEffective		
        this.chkisEffective.setText(resHelper.getString("chkisEffective.text"));		
        this.chkisEffective.setVisible(true);		
        this.chkisEffective.setHorizontalAlignment(2);
        // prmtCreator		
        this.prmtCreator.setEnabled(false);
        // kDDateCreateTime		
        this.kDDateCreateTime.setTimeEnabled(true);		
        this.kDDateCreateTime.setEnabled(false);
        // prmtLastUpdateUser		
        this.prmtLastUpdateUser.setEnabled(false);
        // kDDateLastUpdateTime		
        this.kDDateLastUpdateTime.setTimeEnabled(true);		
        this.kDDateLastUpdateTime.setEnabled(false);
        // txtNumber		
        this.txtNumber.setMaxLength(80);
        // pkBizDate		
        this.pkBizDate.setVisible(true);		
        this.pkBizDate.setEnabled(true);
        // txtDescription		
        this.txtDescription.setMaxLength(80);
        // prmtAuditor		
        this.prmtAuditor.setEnabled(false);
        // pkeffectiveDate		
        this.pkeffectiveDate.setVisible(true);		
        this.pkeffectiveDate.setRequired(false);
        // scrollPaneapplyReason
        // txtapplyReason		
        this.txtapplyReason.setVisible(true);		
        this.txtapplyReason.setRequired(false);		
        this.txtapplyReason.setMaxLength(2000);
        // prmtapplyPerson		
        this.prmtapplyPerson.setQueryInfo("com.kingdee.eas.basedata.person.app.PersonQuery");		
        this.prmtapplyPerson.setVisible(true);		
        this.prmtapplyPerson.setEditable(true);		
        this.prmtapplyPerson.setDisplayFormat("$name$");		
        this.prmtapplyPerson.setEditFormat("$number$");		
        this.prmtapplyPerson.setCommitFormat("$number$");		
        this.prmtapplyPerson.setRequired(false);
        this.setFocusTraversalPolicy(new com.kingdee.bos.ui.UIFocusTraversalPolicy(new java.awt.Component[] {pkeffectiveDate,txtapplyReason,prmtapplyPerson,chkisEffective}));
        this.setFocusCycleRoot(true);
		//Register control's property binding
		registerBindings();
		registerUIState();


    }

	public com.kingdee.bos.ctrl.swing.KDToolBar[] getUIMultiToolBar(){
		java.util.List list = new java.util.ArrayList();
		com.kingdee.bos.ctrl.swing.KDToolBar[] bars = super.getUIMultiToolBar();
		if (bars != null) {
			list.addAll(java.util.Arrays.asList(bars));
		}
		return (com.kingdee.bos.ctrl.swing.KDToolBar[])list.toArray(new com.kingdee.bos.ctrl.swing.KDToolBar[list.size()]);
	}




    /**
     * output initUIContentLayout method
     */
    public void initUIContentLayout()
    {
        this.setBounds(new Rectangle(0, 0, 1013, 629));
        this.setLayout(null);
        contCreator.setBounds(new Rectangle(440, 524, 270, 19));
        this.add(contCreator, null);
        contCreateTime.setBounds(new Rectangle(730, 524, 270, 19));
        this.add(contCreateTime, null);
        contLastUpdateUser.setBounds(new Rectangle(440, 555, 270, 19));
        this.add(contLastUpdateUser, null);
        contLastUpdateTime.setBounds(new Rectangle(730, 555, 270, 19));
        this.add(contLastUpdateTime, null);
        contNumber.setBounds(new Rectangle(728, 26, 270, 19));
        this.add(contNumber, null);
        contBizDate.setBounds(new Rectangle(350, 66, 270, 19));
        this.add(contBizDate, null);
        contDescription.setBounds(new Rectangle(728, 66, 270, 19));
        this.add(contDescription, null);
        contAuditor.setBounds(new Rectangle(15, 528, 270, 19));
        this.add(contAuditor, null);
        conteffectiveDate.setBounds(new Rectangle(0, 0, 270, 19));
        this.add(conteffectiveDate, null);
        contapplyReason.setBounds(new Rectangle(0, 0, 270, 19));
        this.add(contapplyReason, null);
        contapplyPerson.setBounds(new Rectangle(0, 0, 270, 19));
        this.add(contapplyPerson, null);
        kdtRolePermApplys.setBounds(new Rectangle(0, 0, 600, 170));
        kdtRolePermApplys_detailPanel = (com.kingdee.eas.framework.client.multiDetail.DetailPanel)com.kingdee.eas.framework.client.multiDetail.HMDUtils.buildDetail(this,dataBinder,kdtRolePermApplys,new com.kingdee.eas.custom.permissioncontrol.PermApplyBillRolePermApplyInfo(),null,false);
        this.add(kdtRolePermApplys_detailPanel, null);
		kdtRolePermApplys_detailPanel.addAddListener(new com.kingdee.eas.framework.client.multiDetail.IDetailPanelListener() {
			public void beforeEvent(com.kingdee.eas.framework.client.multiDetail.DetailPanelEvent event) throws Exception {
				IObjectValue vo = event.getObjectValue();
vo.put("operationType","1");
			}
			public void afterEvent(com.kingdee.eas.framework.client.multiDetail.DetailPanelEvent event) throws Exception {
			}
		});
        kdtOrgScopeApply.setBounds(new Rectangle(0, 0, 600, 170));
        kdtOrgScopeApply_detailPanel = (com.kingdee.eas.framework.client.multiDetail.DetailPanel)com.kingdee.eas.framework.client.multiDetail.HMDUtils.buildDetail(this,dataBinder,kdtOrgScopeApply,new com.kingdee.eas.custom.permissioncontrol.PermApplyBillOrgScopeApplyInfo(),null,false);
        this.add(kdtOrgScopeApply_detailPanel, null);
        kdtHisRolePermApplyHis.setBounds(new Rectangle(0, 0, 600, 170));
        kdtHisRolePermApplyHis_detailPanel = (com.kingdee.eas.framework.client.multiDetail.DetailPanel)com.kingdee.eas.framework.client.multiDetail.HMDUtils.buildDetail(this,dataBinder,kdtHisRolePermApplyHis,new com.kingdee.eas.custom.permissioncontrol.PermApplyBillHisRolePermApplyHiInfo(),null,false);
        this.add(kdtHisRolePermApplyHis_detailPanel, null);
        kdtHisOrgScopeApplyEntry.setBounds(new Rectangle(0, 0, 600, 170));
        kdtHisOrgScopeApplyEntry_detailPanel = (com.kingdee.eas.framework.client.multiDetail.DetailPanel)com.kingdee.eas.framework.client.multiDetail.HMDUtils.buildDetail(this,dataBinder,kdtHisOrgScopeApplyEntry,new com.kingdee.eas.custom.permissioncontrol.PermApplyBillHisOrgScopeApplyEntryInfo(),null,false);
        this.add(kdtHisOrgScopeApplyEntry_detailPanel, null);
        chkisEffective.setBounds(new Rectangle(0, 0, 270, 19));
        this.add(chkisEffective, null);
        //contCreator
        contCreator.setBoundEditor(prmtCreator);
        //contCreateTime
        contCreateTime.setBoundEditor(kDDateCreateTime);
        //contLastUpdateUser
        contLastUpdateUser.setBoundEditor(prmtLastUpdateUser);
        //contLastUpdateTime
        contLastUpdateTime.setBoundEditor(kDDateLastUpdateTime);
        //contNumber
        contNumber.setBoundEditor(txtNumber);
        //contBizDate
        contBizDate.setBoundEditor(pkBizDate);
        //contDescription
        contDescription.setBoundEditor(txtDescription);
        //contAuditor
        contAuditor.setBoundEditor(prmtAuditor);
        //conteffectiveDate
        conteffectiveDate.setBoundEditor(pkeffectiveDate);
        //contapplyReason
        contapplyReason.setBoundEditor(scrollPaneapplyReason);
        //scrollPaneapplyReason
        scrollPaneapplyReason.getViewport().add(txtapplyReason, null);
        //contapplyPerson
        contapplyPerson.setBoundEditor(prmtapplyPerson);

    }


    /**
     * output initUIMenuBarLayout method
     */
    public void initUIMenuBarLayout()
    {
        this.menuBar.add(menuFile);
        this.menuBar.add(menuEdit);
        this.menuBar.add(MenuService);
        this.menuBar.add(menuView);
        this.menuBar.add(menuBiz);
        this.menuBar.add(menuTable1);
        this.menuBar.add(menuTool);
        this.menuBar.add(menuWorkflow);
        this.menuBar.add(menuHelp);
        //menuFile
        menuFile.add(menuItemAddNew);
        menuFile.add(kDSeparator1);
        menuFile.add(menuItemCloudFeed);
        menuFile.add(menuItemSave);
        menuFile.add(menuItemCloudScreen);
        menuFile.add(menuItemSubmit);
        menuFile.add(menuItemCloudShare);
        menuFile.add(menuSubmitOption);
        menuFile.add(kdSeparatorFWFile1);
        menuFile.add(rMenuItemSubmit);
        menuFile.add(rMenuItemSubmitAndAddNew);
        menuFile.add(rMenuItemSubmitAndPrint);
        menuFile.add(separatorFile1);
        menuFile.add(MenuItemAttachment);
        menuFile.add(kDSeparator2);
        menuFile.add(menuItemPageSetup);
        menuFile.add(menuItemPrint);
        menuFile.add(menuItemPrintPreview);
        menuFile.add(kDSeparator6);
        menuFile.add(menuItemSendMail);
        menuFile.add(kDSeparator3);
        menuFile.add(menuItemExitCurrent);
        //menuSubmitOption
        menuSubmitOption.add(chkMenuItemSubmitAndAddNew);
        menuSubmitOption.add(chkMenuItemSubmitAndPrint);
        //menuEdit
        menuEdit.add(menuItemCopy);
        menuEdit.add(menuItemEdit);
        menuEdit.add(menuItemRemove);
        menuEdit.add(kDSeparator4);
        menuEdit.add(menuItemReset);
        menuEdit.add(separator1);
        menuEdit.add(menuItemCreateFrom);
        menuEdit.add(menuItemCreateTo);
        menuEdit.add(menuItemCopyFrom);
        menuEdit.add(separatorEdit1);
        menuEdit.add(menuItemEnterToNextRow);
        menuEdit.add(separator2);
        //MenuService
        MenuService.add(MenuItemKnowStore);
        MenuService.add(MenuItemAnwser);
        MenuService.add(SepratorService);
        MenuService.add(MenuItemRemoteAssist);
        //menuView
        menuView.add(menuItemFirst);
        menuView.add(menuItemPre);
        menuView.add(menuItemNext);
        menuView.add(menuItemLast);
        menuView.add(separator3);
        menuView.add(menuItemTraceUp);
        menuView.add(menuItemTraceDown);
        menuView.add(kDSeparator7);
        menuView.add(menuItemLocate);
        //menuBiz
        menuBiz.add(menuItemCancelCancel);
        menuBiz.add(menuItemCancel);
        menuBiz.add(MenuItemVoucher);
        menuBiz.add(menuItemDelVoucher);
        menuBiz.add(MenuItemPCVoucher);
        menuBiz.add(menuItemDelPCVoucher);
        //menuTable1
        menuTable1.add(menuItemAddLine);
        menuTable1.add(menuItemCopyLine);
        menuTable1.add(menuItemInsertLine);
        menuTable1.add(menuItemRemoveLine);
        //menuTool
        menuTool.add(menuItemSendMessage);
        menuTool.add(menuItemMsgFormat);
        menuTool.add(menuItemCalculator);
        menuTool.add(menuItemToolBarCustom);
        //menuWorkflow
        menuWorkflow.add(menuItemStartWorkFlow);
        menuWorkflow.add(separatorWF1);
        menuWorkflow.add(menuItemViewSubmitProccess);
        menuWorkflow.add(menuItemViewDoProccess);
        menuWorkflow.add(MenuItemWFG);
        menuWorkflow.add(menuItemWorkFlowList);
        menuWorkflow.add(separatorWF2);
        menuWorkflow.add(menuItemMultiapprove);
        menuWorkflow.add(menuItemNextPerson);
        menuWorkflow.add(menuItemAuditResult);
        menuWorkflow.add(kDSeparator5);
        menuWorkflow.add(kDMenuItemSendMessage);
        //menuHelp
        menuHelp.add(menuItemHelp);
        menuHelp.add(kDSeparator12);
        menuHelp.add(menuItemRegPro);
        menuHelp.add(menuItemPersonalSite);
        menuHelp.add(helpseparatorDiv);
        menuHelp.add(menuitemProductval);
        menuHelp.add(kDSeparatorProduct);
        menuHelp.add(menuItemAbout);

    }

    /**
     * output initUIToolBarLayout method
     */
    public void initUIToolBarLayout()
    {
        this.toolBar.add(btnAddNew);
        this.toolBar.add(btnCloud);
        this.toolBar.add(btnEdit);
        this.toolBar.add(btnXunTong);
        this.toolBar.add(btnSave);
        this.toolBar.add(kDSeparatorCloud);
        this.toolBar.add(btnReset);
        this.toolBar.add(btnSubmit);
        this.toolBar.add(btnCopy);
        this.toolBar.add(btnRemove);
        this.toolBar.add(btnCancelCancel);
        this.toolBar.add(btnCancel);
        this.toolBar.add(btnAttachment);
        this.toolBar.add(separatorFW1);
        this.toolBar.add(btnPageSetup);
        this.toolBar.add(btnPrint);
        this.toolBar.add(btnPrintPreview);
        this.toolBar.add(separatorFW2);
        this.toolBar.add(btnFirst);
        this.toolBar.add(btnPre);
        this.toolBar.add(btnNext);
        this.toolBar.add(btnLast);
        this.toolBar.add(separatorFW3);
        this.toolBar.add(btnTraceUp);
        this.toolBar.add(btnTraceDown);
        this.toolBar.add(btnWorkFlowG);
        this.toolBar.add(btnSignature);
        this.toolBar.add(btnViewSignature);
        this.toolBar.add(separatorFW4);
        this.toolBar.add(btnNumberSign);
        this.toolBar.add(separatorFW7);
        this.toolBar.add(btnCreateFrom);
        this.toolBar.add(btnCopyFrom);
        this.toolBar.add(btnCreateTo);
        this.toolBar.add(separatorFW5);
        this.toolBar.add(separatorFW8);
        this.toolBar.add(btnAddLine);
        this.toolBar.add(btnCopyLine);
        this.toolBar.add(btnInsertLine);
        this.toolBar.add(btnRemoveLine);
        this.toolBar.add(separatorFW6);
        this.toolBar.add(separatorFW9);
        this.toolBar.add(btnVoucher);
        this.toolBar.add(btnDelVoucher);
        this.toolBar.add(btnPCVoucher);
        this.toolBar.add(btnDelPCVoucher);
        this.toolBar.add(btnAuditResult);
        this.toolBar.add(btnMultiapprove);
        this.toolBar.add(btnWFViewdoProccess);
        this.toolBar.add(btnWFViewSubmitProccess);
        this.toolBar.add(btnNextPerson);


    }

	//Regiester control's property binding.
	private void registerBindings(){
		dataBinder.registerBinding("rolePermApplys.seq", int.class, this.kdtRolePermApplys, "seq.text");
		dataBinder.registerBinding("RolePermApplys", com.kingdee.eas.custom.permissioncontrol.PermApplyBillRolePermApplyInfo.class, this.kdtRolePermApplys, "userObject");
		dataBinder.registerBinding("rolePermApplys.role", java.lang.Object.class, this.kdtRolePermApplys, "role.text");
		dataBinder.registerBinding("rolePermApplys.permCount", int.class, this.kdtRolePermApplys, "permCount.text");
		dataBinder.registerBinding("rolePermApplys.remark", String.class, this.kdtRolePermApplys, "remark.text");
		dataBinder.registerBinding("rolePermApplys.operationType", com.kingdee.util.enums.Enum.class, this.kdtRolePermApplys, "operationType.text");
		dataBinder.registerBinding("orgScopeApply.seq", int.class, this.kdtOrgScopeApply, "seq.text");
		dataBinder.registerBinding("OrgScopeApply", com.kingdee.eas.custom.permissioncontrol.PermApplyBillOrgScopeApplyInfo.class, this.kdtOrgScopeApply, "userObject");
		dataBinder.registerBinding("orgScopeApply.orgUnit", java.lang.Object.class, this.kdtOrgScopeApply, "orgUnit.text");
		dataBinder.registerBinding("orgScopeApply.isIncludeSub", boolean.class, this.kdtOrgScopeApply, "isIncludeSub.text");
		dataBinder.registerBinding("hisRolePermApplyHis.seq", int.class, this.kdtHisRolePermApplyHis, "seq.text");
		dataBinder.registerBinding("HisRolePermApplyHis", com.kingdee.eas.custom.permissioncontrol.PermApplyBillHisRolePermApplyHiInfo.class, this.kdtHisRolePermApplyHis, "userObject");
		dataBinder.registerBinding("hisRolePermApplyHis.role", java.lang.Object.class, this.kdtHisRolePermApplyHis, "role.text");
		dataBinder.registerBinding("hisOrgScopeApplyEntry.seq", int.class, this.kdtHisOrgScopeApplyEntry, "seq.text");
		dataBinder.registerBinding("HisOrgScopeApplyEntry", com.kingdee.eas.custom.permissioncontrol.PermApplyBillHisOrgScopeApplyEntryInfo.class, this.kdtHisOrgScopeApplyEntry, "userObject");
		dataBinder.registerBinding("hisOrgScopeApplyEntry.orgUnit", java.lang.Object.class, this.kdtHisOrgScopeApplyEntry, "orgUnit.text");
		dataBinder.registerBinding("hisOrgScopeApplyEntry.isIncludeSub", boolean.class, this.kdtHisOrgScopeApplyEntry, "isIncludeSub.text");
		dataBinder.registerBinding("isEffective", boolean.class, this.chkisEffective, "selected");
		dataBinder.registerBinding("creator", com.kingdee.eas.base.permission.UserInfo.class, this.prmtCreator, "data");
		dataBinder.registerBinding("createTime", java.sql.Timestamp.class, this.kDDateCreateTime, "value");
		dataBinder.registerBinding("lastUpdateUser", com.kingdee.eas.base.permission.UserInfo.class, this.prmtLastUpdateUser, "data");
		dataBinder.registerBinding("lastUpdateTime", java.sql.Timestamp.class, this.kDDateLastUpdateTime, "value");
		dataBinder.registerBinding("number", String.class, this.txtNumber, "text");
		dataBinder.registerBinding("bizDate", java.util.Date.class, this.pkBizDate, "value");
		dataBinder.registerBinding("description", String.class, this.txtDescription, "text");
		dataBinder.registerBinding("auditor", com.kingdee.eas.base.permission.UserInfo.class, this.prmtAuditor, "data");
		dataBinder.registerBinding("effectiveDate", java.util.Date.class, this.pkeffectiveDate, "value");
		dataBinder.registerBinding("applyReason", String.class, this.txtapplyReason, "text");
		dataBinder.registerBinding("applyPerson", com.kingdee.eas.basedata.person.PersonInfo.class, this.prmtapplyPerson, "data");		
	}
	//Regiester UI State
	private void registerUIState(){		
	}
	public String getUIHandlerClassName() {
	    return "com.kingdee.eas.custom.permissioncontrol.app.PermApplyBillEditUIHandler";
	}
	public IUIActionPostman prepareInit() {
		IUIActionPostman clientHanlder = super.prepareInit();
		if (clientHanlder != null) {
			RequestContext request = new RequestContext();
    		request.setClassName(getUIHandlerClassName());
			clientHanlder.setRequestContext(request);
		}
		return clientHanlder;
    }
	
	public boolean isPrepareInit() {
    	return false;
    }
    protected void initUIP() {
        super.initUIP();
    }


    /**
     * output onShow method
     */
    public void onShow() throws Exception
    {
        super.onShow();
        this.pkeffectiveDate.requestFocusInWindow();
    }

	
	

    /**
     * output setDataObject method
     */
    public void setDataObject(IObjectValue dataObject)
    {
        IObjectValue ov = dataObject;        	    	
        super.setDataObject(ov);
        this.editData = (com.kingdee.eas.custom.permissioncontrol.PermApplyBillInfo)ov;
    }
    protected void removeByPK(IObjectPK pk) throws Exception {
    	IObjectValue editData = this.editData;
    	super.removeByPK(pk);
    	recycleNumberByOrg(editData,"NONE",editData.getString("number"));
    }
    
    protected void recycleNumberByOrg(IObjectValue editData,String orgType,String number) {
        if (!StringUtils.isEmpty(number))
        {
            try {
            	String companyID = null;            
            	com.kingdee.eas.base.codingrule.ICodingRuleManager iCodingRuleManager = com.kingdee.eas.base.codingrule.CodingRuleManagerFactory.getRemoteInstance();
				if(!com.kingdee.util.StringUtils.isEmpty(orgType) && !"NONE".equalsIgnoreCase(orgType) && com.kingdee.eas.common.client.SysContext.getSysContext().getCurrentOrgUnit(com.kingdee.eas.basedata.org.OrgType.getEnum(orgType))!=null) {
					companyID =com.kingdee.eas.common.client.SysContext.getSysContext().getCurrentOrgUnit(com.kingdee.eas.basedata.org.OrgType.getEnum(orgType)).getString("id");
				}
				else if (com.kingdee.eas.common.client.SysContext.getSysContext().getCurrentOrgUnit() != null) {
					companyID = ((com.kingdee.eas.basedata.org.OrgUnitInfo)com.kingdee.eas.common.client.SysContext.getSysContext().getCurrentOrgUnit()).getString("id");
            	}				
				if (!StringUtils.isEmpty(companyID) && iCodingRuleManager.isExist(editData, companyID) && iCodingRuleManager.isUseIntermitNumber(editData, companyID)) {
					iCodingRuleManager.recycleNumber(editData,companyID,number);					
				}
            }
            catch (Exception e)
            {
                handUIException(e);
            }
        }
    }
    protected void setAutoNumberByOrg(String orgType) {
    	if (editData == null) return;
		if (editData.getNumber() == null) {
            try {
            	String companyID = null;
				if(!com.kingdee.util.StringUtils.isEmpty(orgType) && !"NONE".equalsIgnoreCase(orgType) && com.kingdee.eas.common.client.SysContext.getSysContext().getCurrentOrgUnit(com.kingdee.eas.basedata.org.OrgType.getEnum(orgType))!=null) {
					companyID = com.kingdee.eas.common.client.SysContext.getSysContext().getCurrentOrgUnit(com.kingdee.eas.basedata.org.OrgType.getEnum(orgType)).getString("id");
				}
				else if (com.kingdee.eas.common.client.SysContext.getSysContext().getCurrentOrgUnit() != null) {
					companyID = ((com.kingdee.eas.basedata.org.OrgUnitInfo)com.kingdee.eas.common.client.SysContext.getSysContext().getCurrentOrgUnit()).getString("id");
            	}
				com.kingdee.eas.base.codingrule.ICodingRuleManager iCodingRuleManager = com.kingdee.eas.base.codingrule.CodingRuleManagerFactory.getRemoteInstance();
		        if (iCodingRuleManager.isExist(editData, companyID)) {
		            if (iCodingRuleManager.isAddView(editData, companyID)) {
		            	editData.setNumber(iCodingRuleManager.getNumber(editData,companyID));
		            }
	                txtNumber.setEnabled(false);
		        }
            }
            catch (Exception e) {
                handUIException(e);
                this.oldData = editData;
                com.kingdee.eas.util.SysUtil.abort();
            } 
        } 
        else {
            if (editData.getNumber().trim().length() > 0) {
                txtNumber.setText(editData.getNumber());
            }
        }
    }

    /**
     * output loadFields method
     */
    public void loadFields()
    {
        		setAutoNumberByOrg("NONE");
        dataBinder.loadFields();
    }
		protected void setOrgF7(KDBizPromptBox f7,com.kingdee.eas.basedata.org.OrgType orgType) throws Exception
		{
			com.kingdee.eas.basedata.org.client.f7.NewOrgUnitFilterInfoProducer oufip = new com.kingdee.eas.basedata.org.client.f7.NewOrgUnitFilterInfoProducer(orgType);
			oufip.getModel().setIsCUFilter(true);
			f7.setFilterInfoProducer(oufip);
		}

    /**
     * output storeFields method
     */
    public void storeFields()
    {
		dataBinder.storeFields();
    }

	/**
	 * ????????งต??
	 */
	protected void registerValidator() {
    	getValidateHelper().setCustomValidator( getValidator() );
		getValidateHelper().registerBindProperty("rolePermApplys.seq", ValidateHelper.ON_SAVE);    
		getValidateHelper().registerBindProperty("RolePermApplys", ValidateHelper.ON_SAVE);    
		getValidateHelper().registerBindProperty("rolePermApplys.role", ValidateHelper.ON_SAVE);    
		getValidateHelper().registerBindProperty("rolePermApplys.permCount", ValidateHelper.ON_SAVE);    
		getValidateHelper().registerBindProperty("rolePermApplys.remark", ValidateHelper.ON_SAVE);    
		getValidateHelper().registerBindProperty("rolePermApplys.operationType", ValidateHelper.ON_SAVE);    
		getValidateHelper().registerBindProperty("orgScopeApply.seq", ValidateHelper.ON_SAVE);    
		getValidateHelper().registerBindProperty("OrgScopeApply", ValidateHelper.ON_SAVE);    
		getValidateHelper().registerBindProperty("orgScopeApply.orgUnit", ValidateHelper.ON_SAVE);    
		getValidateHelper().registerBindProperty("orgScopeApply.isIncludeSub", ValidateHelper.ON_SAVE);    
		getValidateHelper().registerBindProperty("hisRolePermApplyHis.seq", ValidateHelper.ON_SAVE);    
		getValidateHelper().registerBindProperty("HisRolePermApplyHis", ValidateHelper.ON_SAVE);    
		getValidateHelper().registerBindProperty("hisRolePermApplyHis.role", ValidateHelper.ON_SAVE);    
		getValidateHelper().registerBindProperty("hisOrgScopeApplyEntry.seq", ValidateHelper.ON_SAVE);    
		getValidateHelper().registerBindProperty("HisOrgScopeApplyEntry", ValidateHelper.ON_SAVE);    
		getValidateHelper().registerBindProperty("hisOrgScopeApplyEntry.orgUnit", ValidateHelper.ON_SAVE);    
		getValidateHelper().registerBindProperty("hisOrgScopeApplyEntry.isIncludeSub", ValidateHelper.ON_SAVE);    
		getValidateHelper().registerBindProperty("isEffective", ValidateHelper.ON_SAVE);    
		getValidateHelper().registerBindProperty("creator", ValidateHelper.ON_SAVE);    
		getValidateHelper().registerBindProperty("createTime", ValidateHelper.ON_SAVE);    
		getValidateHelper().registerBindProperty("lastUpdateUser", ValidateHelper.ON_SAVE);    
		getValidateHelper().registerBindProperty("lastUpdateTime", ValidateHelper.ON_SAVE);    
		getValidateHelper().registerBindProperty("number", ValidateHelper.ON_SAVE);    
		getValidateHelper().registerBindProperty("bizDate", ValidateHelper.ON_SAVE);    
		getValidateHelper().registerBindProperty("description", ValidateHelper.ON_SAVE);    
		getValidateHelper().registerBindProperty("auditor", ValidateHelper.ON_SAVE);    
		getValidateHelper().registerBindProperty("effectiveDate", ValidateHelper.ON_SAVE);    
		getValidateHelper().registerBindProperty("applyReason", ValidateHelper.ON_SAVE);    
		getValidateHelper().registerBindProperty("applyPerson", ValidateHelper.ON_SAVE);    		
	}



    /**
     * output setOprtState method
     */
    public void setOprtState(String oprtType)
    {
        super.setOprtState(oprtType);
        if (STATUS_ADDNEW.equals(this.oprtState)) {
        } else if (STATUS_EDIT.equals(this.oprtState)) {
        } else if (STATUS_VIEW.equals(this.oprtState)) {
        } else if (STATUS_FINDVIEW.equals(this.oprtState)) {
        }
    }

    /**
     * output getSelectors method
     */
    public SelectorItemCollection getSelectors()
    {
        SelectorItemCollection sic = new SelectorItemCollection();
		String selectorAll = System.getProperty("selector.all");
		if(StringUtils.isEmpty(selectorAll)){
			selectorAll = "true";
		}
    	sic.add(new SelectorItemInfo("rolePermApplys.seq"));
		if(selectorAll.equalsIgnoreCase("true"))
		{
			sic.add(new SelectorItemInfo("RolePermApplys.*"));
		}
		else{
		}
		if(selectorAll.equalsIgnoreCase("true"))
		{
			sic.add(new SelectorItemInfo("rolePermApplys.role.*"));
		}
		else{
	    	sic.add(new SelectorItemInfo("rolePermApplys.role.id"));
			sic.add(new SelectorItemInfo("rolePermApplys.role.name"));
        	sic.add(new SelectorItemInfo("rolePermApplys.role.number"));
		}
    	sic.add(new SelectorItemInfo("rolePermApplys.permCount"));
    	sic.add(new SelectorItemInfo("rolePermApplys.remark"));
    	sic.add(new SelectorItemInfo("rolePermApplys.operationType"));
    	sic.add(new SelectorItemInfo("orgScopeApply.seq"));
		if(selectorAll.equalsIgnoreCase("true"))
		{
			sic.add(new SelectorItemInfo("OrgScopeApply.*"));
		}
		else{
		}
		if(selectorAll.equalsIgnoreCase("true"))
		{
			sic.add(new SelectorItemInfo("orgScopeApply.orgUnit.*"));
		}
		else{
	    	sic.add(new SelectorItemInfo("orgScopeApply.orgUnit.id"));
			sic.add(new SelectorItemInfo("orgScopeApply.orgUnit.name"));
        	sic.add(new SelectorItemInfo("orgScopeApply.orgUnit.number"));
		}
    	sic.add(new SelectorItemInfo("orgScopeApply.isIncludeSub"));
    	sic.add(new SelectorItemInfo("hisRolePermApplyHis.seq"));
		if(selectorAll.equalsIgnoreCase("true"))
		{
			sic.add(new SelectorItemInfo("HisRolePermApplyHis.*"));
		}
		else{
		}
		if(selectorAll.equalsIgnoreCase("true"))
		{
			sic.add(new SelectorItemInfo("hisRolePermApplyHis.role.*"));
		}
		else{
	    	sic.add(new SelectorItemInfo("hisRolePermApplyHis.role.id"));
			sic.add(new SelectorItemInfo("hisRolePermApplyHis.role.name"));
        	sic.add(new SelectorItemInfo("hisRolePermApplyHis.role.number"));
		}
    	sic.add(new SelectorItemInfo("hisOrgScopeApplyEntry.seq"));
		if(selectorAll.equalsIgnoreCase("true"))
		{
			sic.add(new SelectorItemInfo("HisOrgScopeApplyEntry.*"));
		}
		else{
		}
		if(selectorAll.equalsIgnoreCase("true"))
		{
			sic.add(new SelectorItemInfo("hisOrgScopeApplyEntry.orgUnit.*"));
		}
		else{
	    	sic.add(new SelectorItemInfo("hisOrgScopeApplyEntry.orgUnit.id"));
			sic.add(new SelectorItemInfo("hisOrgScopeApplyEntry.orgUnit.name"));
        	sic.add(new SelectorItemInfo("hisOrgScopeApplyEntry.orgUnit.number"));
		}
    	sic.add(new SelectorItemInfo("hisOrgScopeApplyEntry.isIncludeSub"));
        sic.add(new SelectorItemInfo("isEffective"));
		if(selectorAll.equalsIgnoreCase("true"))
		{
			sic.add(new SelectorItemInfo("creator.*"));
		}
		else{
        	sic.add(new SelectorItemInfo("creator.id"));
        	sic.add(new SelectorItemInfo("creator.number"));
        	sic.add(new SelectorItemInfo("creator.name"));
		}
        sic.add(new SelectorItemInfo("createTime"));
		if(selectorAll.equalsIgnoreCase("true"))
		{
			sic.add(new SelectorItemInfo("lastUpdateUser.*"));
		}
		else{
        	sic.add(new SelectorItemInfo("lastUpdateUser.id"));
        	sic.add(new SelectorItemInfo("lastUpdateUser.number"));
        	sic.add(new SelectorItemInfo("lastUpdateUser.name"));
		}
        sic.add(new SelectorItemInfo("lastUpdateTime"));
        sic.add(new SelectorItemInfo("number"));
        sic.add(new SelectorItemInfo("bizDate"));
        sic.add(new SelectorItemInfo("description"));
		if(selectorAll.equalsIgnoreCase("true"))
		{
			sic.add(new SelectorItemInfo("auditor.*"));
		}
		else{
        	sic.add(new SelectorItemInfo("auditor.id"));
        	sic.add(new SelectorItemInfo("auditor.number"));
        	sic.add(new SelectorItemInfo("auditor.name"));
		}
        sic.add(new SelectorItemInfo("effectiveDate"));
        sic.add(new SelectorItemInfo("applyReason"));
		if(selectorAll.equalsIgnoreCase("true"))
		{
			sic.add(new SelectorItemInfo("applyPerson.*"));
		}
		else{
        	sic.add(new SelectorItemInfo("applyPerson.id"));
        	sic.add(new SelectorItemInfo("applyPerson.number"));
        	sic.add(new SelectorItemInfo("applyPerson.name"));
		}
        return sic;
    }        
    	

    /**
     * output actionSubmit_actionPerformed method
     */
    public void actionSubmit_actionPerformed(ActionEvent e) throws Exception
    {
        super.actionSubmit_actionPerformed(e);
    }
    	

    /**
     * output actionPrint_actionPerformed method
     */
    public void actionPrint_actionPerformed(ActionEvent e) throws Exception
    {
        super.actionPrint_actionPerformed(e);
    }
    	

    /**
     * output actionPrintPreview_actionPerformed method
     */
    public void actionPrintPreview_actionPerformed(ActionEvent e) throws Exception
    {
        super.actionPrintPreview_actionPerformed(e);
    }
	public RequestContext prepareActionSubmit(IItemAction itemAction) throws Exception {
			RequestContext request = super.prepareActionSubmit(itemAction);		
		if (request != null) {
    		request.setClassName(getUIHandlerClassName());
		}
		return request;
    }
	
	public boolean isPrepareActionSubmit() {
    	return false;
    }
	public RequestContext prepareActionPrint(IItemAction itemAction) throws Exception {
			RequestContext request = super.prepareActionPrint(itemAction);		
		if (request != null) {
    		request.setClassName(getUIHandlerClassName());
		}
		return request;
    }
	
	public boolean isPrepareActionPrint() {
    	return false;
    }
	public RequestContext prepareActionPrintPreview(IItemAction itemAction) throws Exception {
			RequestContext request = super.prepareActionPrintPreview(itemAction);		
		if (request != null) {
    		request.setClassName(getUIHandlerClassName());
		}
		return request;
    }
	
	public boolean isPrepareActionPrintPreview() {
    	return false;
    }

    /**
     * output getMetaDataPK method
     */
    public IMetaDataPK getMetaDataPK()
    {
        return new MetaDataPK("com.kingdee.eas.custom.permissioncontrol.client", "PermApplyBillEditUI");
    }
    /**
     * output isBindWorkFlow method
     */
    public boolean isBindWorkFlow()
    {
        return true;
    }

    /**
     * output getEditUIName method
     */
    protected String getEditUIName()
    {
        return com.kingdee.eas.custom.permissioncontrol.client.PermApplyBillEditUI.class.getName();
    }

    /**
     * output getBizInterface method
     */
    protected com.kingdee.eas.framework.ICoreBase getBizInterface() throws Exception
    {
        return com.kingdee.eas.custom.permissioncontrol.PermApplyBillFactory.getRemoteInstance();
    }

    /**
     * output createNewData method
     */
    protected IObjectValue createNewData()
    {
        com.kingdee.eas.custom.permissioncontrol.PermApplyBillInfo objectValue = new com.kingdee.eas.custom.permissioncontrol.PermApplyBillInfo();
        objectValue.setCreator((com.kingdee.eas.base.permission.UserInfo)(com.kingdee.eas.common.client.SysContext.getSysContext().getCurrentUser()));		
        return objectValue;
    }


    	protected String getTDFileName() {
    	return "/bim/custom/permissioncontrol/PermApplyBill";
	}
    protected IMetaDataPK getTDQueryPK() {
    	return new MetaDataPK("com.kingdee.eas.custom.permissioncontrol.app.PermApplyBillQuery");
	}
    

    /**
     * output getDetailTable method
     */
    protected KDTable getDetailTable() {
        return kdtRolePermApplys;
	}
    /**
     * output applyDefaultValue method
     */
    protected void applyDefaultValue(IObjectValue vo) {        
    }        
	protected void setFieldsNull(com.kingdee.bos.dao.AbstractObjectValue arg0) {
		super.setFieldsNull(arg0);
		arg0.put("number",null);
	}

}